replicaCount: 1

image:
  # -- The repository for the image. By default, 
  # this points to the Software AG container repository. 
  # Change this for air-gapped installations or custom images.
  # For the Software AG container repository you need to have a 
  # valid access token stored as registry credentials
  repository: sagcr.azurecr.io/apigateway-minimal
  pullPolicy: IfNotPresent
  # -- The image tag of the apigateway image default this will be the latest version. 
  # For realworld scenarios SAG recommends to use a 
  # specific version to not accidently change production versions with newer images.
  tag: "10.15"

# -- Image pull secret reference. By default looks for `regcred`.
imagePullSecrets: 
  - name: regcred

# -- Controls if secrets should be generated automatically.
secrets:
  generateAdminSecret: true
  generateElasticSecrets: true

# -- Overwrites Chart name of release name in workload name. As default, the workload name is release name + '-' + Chart name. The workload name is at the end release name + '-' + value of `nameOverride`.
nameOverride: ""
# -- Overwrites full workload name. As default, the workload name is release name + '-' + Chart name.
fullnameOverride: ""

serviceAccount:
  # -- Specifies whether a service account should be created
  # if you set this to false, you need to specify an existing service account in 'name'. 
  # A service account is required for the apigateway to access the kubernetes API (i.e, Apache Ignite clustering).
  # The default service account should be as follows:
  #  apiVersion: v1
  # kind: ServiceAccount
  # metadata:
  #   name: {{ include "common.names.serviceAccountName" . }}
  # ---
  # kind: RoleBinding
  # apiVersion: rbac.authorization.k8s.io/v1
  # metadata:
  #   name: cluster-discovery-rolebinding
  # roleRef:
  #   kind: Role
  #   name: {{ include "common.names.roleName" . }}
  #   apiGroup: rbac.authorization.k8s.io
  # subjects:
  # - kind: ServiceAccount
  #   name: {{ include "common.names.serviceAccountName" . }}
  # ---
  # apiVersion: rbac.authorization.k8s.io/v1
  # kind: Role
  # metadata:
  #   name: {{ include "common.names.roleName" . }}
  # rules:
  # - apiGroups:
  #   - ""
  #   resources:
  #   - pods
  #   - endpoints
  #   verbs:
  #   - get
  #   - list
  #   - watch
  create: true
  # -- Annotations to add to the service account
  annotations: {}
  # -- The name of the service account to use.
  # If not set and create is true, a name is generated using the fullname template
  name: ""
  # If not set and create is true, a name is generated using the fullname template
  roleName: ""

# -- The name of the secret or configmap that contains the license key.
# Defaults to the release name + chart name + "-license".
licenseConfigName: ""
# To set the key inside the configmap.
# Defaults to licensekey
licenseConfigKey: ""

podAnnotations: {}

podSecurityContext: {}
  # fsGroup: 2000

securityContext: {}
  # capabilities:
  #   drop:
  #   - ALL
  # readOnlyRootFilesystem: true
  # runAsNonRoot: true
  # runAsUser: 1000

service:
  type: ClusterIP
  port: 80

grpcService:
  enabled: false
  type: LoadBalancer
  azureInternalLoadBalancer: false
  dnsExternal: false
  hostname: ""

# multiple ingresses for ui, admin, ext and rt 
ingresses: 
  ui:
    defaultHost: ""
    enabled: true
    svcName: ""
    svcPort: ""
    className: "nginx"
    annotations: 
      nginx.ingress.kubernetes.io/affinity: "cookie"
      # nginx.ingress.kubernetes.io/backend-protocol: "HTTPS"
    hosts:
      - host:
        paths:
          - path: /
            pathType: Prefix
    tls: 
      - secretName: 
        hosts: 
  rt:
    defaultHost: ""
    enabled: true
    svcName: ""
    svcPort: ""
    className: "nginx"
    annotations: {}
      # nginx.ingress.kubernetes.io/backend-protocol: "HTTPS"
    hosts:
      - host:
        paths:
          - path: /gateway
            pathType: Prefix
    tls: 
      - secretName: 
        hosts:
  admin:
    defaultHost: ""
    enabled: true
    svcName: ""
    svcPort: ""
    className: "nginx"
    annotations: 
      nginx.ingress.kubernetes.io/affinity: "cookie"
    hosts:
      - host:
        paths:
          - path: /
            pathType: Prefix
    tls: 
      - secretName:
        hosts:

# global ingress settings for tls secret name, cert and key
ingress:
  defaultDomain: my-domain.com 
  tls:
    # -- default secret name for TLS. By default empty,
    # will look for <release-name-apigateway->tls".
    secretName: ""
    cert: "" 
    key: ""

resources: 
  # We usually recommend not to specify default resources and to leave this as a conscious
  # choice for the user. This also increases chances charts run on environments with little
  # resources, such as Minikube. If you do want to specify resources, uncomment the following
  # lines, adjust them as necessary, and remove the curly braces after 'resources:'.
  # limits:
  #   cpu: 100m
  #   memory: 128Mi
  # requests:
  #   cpu: 100m
  #   memory: 128Mi
  apigwInitContainer:  
    requests:
      cpu: 100m
      memory: 50Mi
    limits:
      cpu: 200m
      memory: 100Mi
  
  apigwContainer:
    requests:
      cpu: 500m
      memory: 4Gi
    limits:
      # use a high cpu limit to avaoid the container being throttled
      cpu: 8
      memory: 8Gi
  

autoscaling:
  enabled: false
  minReplicas: 1
  maxReplicas: 100
  targetCPUUtilizationPercentage: 80
  # targetMemoryUtilizationPercentage: 80

nodeSelector: {}

tolerations: []

affinity: {}

# -- Value to add extra host aliases to APIGW container.
hostAliases: []

global: 
  curlImage: "curlimages/curl"
  # -- Protocol for health check for kibana startup, must be http / https
  apigwHealthProtocol:             "http"             
  # -- Service name for health check for kibana startup, must same value as apigwAdminService
  apigwHealthService:              "apigw-admin-svc"  
  # -- Port for health check for kibana startup, must same value as apigwAdminPort  
  apigwHealthPort:                 5555          

  # -- Elasticsearch global settings
  # Required for Prometheus Exporter Sub Chart
  elasticsearch: 
    # -- The elasticsearch http service name that API Gateway uses.
    # The default is compiled of the fullname (releasename + chart name) + "-http" 
    # You MUST override this if you use an external elastic search service and do not deploy the embedded elastic CRD from this chart.
    serviceName: ""
    port: 9200

# -- Extra Labels for API Gateway
extraLabels: {}

# -- Exta environment properties to be passed on to the container
extraEnvs: {}

# -- Exta volumes that should be mounted.
# - name: extras
#   emptyDir: {}
extraVolumes: []

# -- Extra volume mounts
# - name: extras
#   mountPath: /usr/share/extras
#   readOnly: true
extraVolumeMounts: []

# -- Extra containers which should run in addition to the main container as a sidecar
# - name: do-something
#   image: busybox
#   command: ['do', 'something']
extraContainers: []

# -- Extra init containers that are executed before starting the main container
# - name: do-something
#   image: busybox
#   command: ['do', 'something']
extraInitContainers: []

# -- Extra config maps for additional configurations such as extra ports, etc.
extraConfigMaps: []

# -- lifecycle hooks to execute on preStop / postStart,...
# preStop:
#   exec:
#     command: ["/bin/sh", "-c", "echo Hello from the postStart handler > /usr/share/message"]
# postStart:
#   exec:
#     command: ["/bin/sh", "-c", "echo Hello from the postStart handler > /usr/share/message"]
lifecycle: {}

apigw:
  # -- Deploy Elasticsearch. Depends on Elasic Search Helm Charts. See https://github.com/elastic/helm-charts/blob/main/elasticsearch  
  elasticSearchDeployment: true

  initMemory: 1024Mi
  maxMemory: 1024Mi

  # -- The API Gateway runtime port for API invocations. By default API Gateway images do not have this port setup. 
  # You must manually set up this port or create post init job that creates this port after API Gateway was initialized.
  runtimePort:             5556
  # -- The API Diagnostics port. 
  diagPort:                9999 
  # -- The default API Administration UI port
  uiPort:                  9072
  # -- The default administration port. Note in a default installation this port will also be used for runtime traffic.
  adminPort:               5555
  # -- External Runtime Port for Reverse Invoke Setups. This port must be manually setup after API Gateway was initizalized.
  runtimeExternalPort:     6555
  # -- gRPC port for High Availability and Fault Tolerance (HAFT) solution. This port must be manually setup after API Gateway was initizalized.
  grpcPort:                4440
  readinessProbe:
    # -- The readinessprobe scheme (https or http).
    scheme:                "HTTP"
  serviceName:             "apigw"
  
  # -- SecurityContext for apigw initContainer
  # Deactivated by default.
  # Usage example:
  # securityContext:
  #   runAsGroup: 1000
  #   runAsUser: 1000
  #   runAsNonRoot: true
  #   allowPrivilegeEscalation: false
  #   capabilities:
  #     drop:
  #       - ALL
  initContainer:
    securityContext: {}
  
  # -- Specifies the location and name of the configuration variables template
  # or the directory containing templates for use with Microservices Runtime or
  # an Integration Server with licensed Microservices functionality. Use a
  # comma-separated list to specify multiple templates and/or directories.
  # See: https://documentation.softwareag.com/webmethods/integration_server/pie10-15/webhelp/pie-webhelp/index.html#page/pie-webhelp%2Fto-sag_environment_variables_2.html
  # Note: should only be used for passing simple configurations such as extended 
  # settings. For all other configurations of API Gateway, use the official 
  # Admin REST API.
  sagIsConfigProperties:   "/config/application.properties"

  uiService:              "apigw-ui-svc"
  rtService:              "apigw-rt-svc"
  rtExternalService:      "apigw-rt-ext-svc"
  apigwAdminService:      "apigw-admin-svc"

  # -- The secret that holds the admin password 
  # Depends on secrets.genereateAdminSecret; if true the setting will be ignored.
  adminSecretName: ""

  # -- The key that holds the admin secret key; defauls to "password"
  adminSecretKey: ""

  # -- The secret that holds the truststore password. If empty the chart will generate the name: fullname + "-es-truststore-secret".
  elastictrustStoreName: ""

  # -- The key that holds the truststore password; defaults to "password"
  elastictrustStorePassKey: ""
  
  # -- The secret that holds the keystore password. If empty the chart will generate the name: fullname + "-es-keystore-secret".
  elastickeyStoreName: ""

  # -- The key that holds the keystore password; defaults to "password"
  elastickeyStorePassKey: ""

  # -- Application Properties to overwrite default API Gateway settings. Please check 
  # Handle with care - Most settings should be set via the UI, Admin API, configSources values, or via environment variables. 
  # By default only the default Administrator password is set through this mechanism if nothing is set here. 
  # Other examples are extended settings which can be set through this mechanism.
  # Examples:
  #
  # Set the default Administrator password from environment variable
  # user.Administrator.password=$env{ADMINISTRATOR_PASSWORD}
  #
  # Avoid archiving audit log files ...
  # settings.watt.server.audit.logFilesToKeep=1
  #
  # Avoid archiving server log files ...
  # settings.watt.server.serverlogFilesToKeep=1
  #
  # Avoid archiving statistic files ...
  # settings.watt.server.stats.logFilesToKeep=1
  #
  # Value for 1 to 9 to set debug level of server log ...
  # settings.watt.debug.level=
  #
  # Set the maximum number of permitted service threads in the global pool ...
  # settings.watt.server.threadPool=750
  #
  # Set the default request/response content-type ...
  # settings.watt.net.default.content-type=json
  #
  # Avoid IS internal statistic data collector ...
  # statisticsdatacollector.monitorConfig.enabled=false  
  applicationProperties: |

  # -- configuration source files for API Gateway
  configSources:

    elasticsearch:      
      tenantId: default
      hosts: "{{ default (printf \"%s-%s-es-http\" .Release.Name .Chart.Name) .Values.global.elasticsearch.serviceName }}:{{ .Values.global.elasticsearch.port }}"
    
    kibana:
      dashboardInstance: "{{ printf \"http://%s-%s-kb-http:%d\" .Release.Name .Chart.Name (int .Values.kibana.port) }}"
      autostart: false

  # -- Extra configuration sources for API Gateway
  # Example: 
  # - type: YAML
  #   allowEdit: false
  #   properties:
  #     location: apigw-config.yml
  extraConfigSources: []

  # -- Additional labels to be added to apigw pod labels.
  extraLabels: {}

prometheus:
  path: "/metrics"
  port: "5555"
  scheme: "http"
  scrape: "true"

metering:

  # -- enable metering 
  enabled: true
  # -- The URL of the metering aggregator server REST API.
  serverUrl: "https://metering.softwareag.cloud/api/measurements"
  # -- Тhe type of the proxy that the metering client uses. 
  # Valid values are: 
  # *DIRECT (default). 
  # *HTTP 
  # *SOCKS
  # Indicates that the metering client does not use a proxy. 
  proxyType: "DIRECT"
  # -- The proxy address in a <host>:<port> format that the metering client uses. 
  # Configure this property only if you use a metering proxy.
  proxyAddress:
  # -- The proxy password that the metering client uses.
  # Configure this property only if you use a metering proxy with authentication.
  # Depending on the method that you use to provide a password, ensure that you escape password characters that are specific for the selected method.
  # Valid characters:
  # *Letters: A-Z, a-z
  # *Numbers: 0-9
  # *Special characters: !@#$%^&*()_+-=[]{}\/?,.<>;
  proxyPass: 
  # -- Тhe time in milliseconds to establish the initial TCP connection when the metering client calls the server REST endpoint. This is also the time to start the request.
  serverConnectTimeout: "60000"
  # -- The maximum time in milliseconds without data transfer over the TCP connection to the server. This is also the time that it takes for the server to respond. When this time passes, the request fails.
  serverReadTimeout: "300000"
  # -- The period in seconds for which data is accumulated before a log record is produced.
  accumulationPeriod: "1800"
  reportPeriod: "3600"
  # -- An alias of the webMethods product instance or a group of instances, for which usage data is measured.
  runtimeAlias:
  # -- The level of log messages that are logged on the console.
  # Valid values are:
  # *error - logs only ERROR messages.
  # *warn (default) - logs ERROR and WARN messages.
  # *info - logs ERROR, WARN, and INFO messages.
  # *debug - logs ERROR, WARN, INFO, and DEBUG messages. Use as a Java system property or an environment variable to see the debug messages of the configuration initialization.
  logLevel:
  # -- The absolute path to the metering client truststore that is used for HTTPS connections. Add this value in any of the following cases:
  # *If you use the Software AG Metering Server on premises (via HTTPS) and the certificates in the truststore do not match the certificates configured in Software AG Runtime (CTP).
  # *If you use a metering proxy that terminates the SSL connection to the Metering Server in Software AG Cloud. 
  trustStoreFile:
  # -- The password for the metering client truststore.
  # Configure this property only if you use a truststore.
  trustStorePassword:

elasticsearch:

  # -- Deploy elastic search instance 
  deploy: true

  # -- The ECK version to be used
  version: 8.2.3

  # -- The image that should be used.
  # By default ECK will use the official Elasticsearch images. 
  # Overwrite this to use an image from an internal registry or any custom images.
  # Make sure that the image corresponds to the version field.
  image: 

  # -- The secret name that holds the sag es user for API Gateway.
  secretName: ""

  # -- The key that holds the Elasticsearch user; defauls to "username"
  secretUserKey: ""

  # -- The key that holds the Elasticsearch password; defauls to "password"
  secretPasswordKey: ""

  # -- Extra Secrets adding or changing built-in users of Elasticsearch.
  # You can use this to limit the roles of the default elastic user.
  # Note if you specify user and roles, the secret will be generated with a random password.
  # If you just specify a name, the secret will be used as is.
  # Example for setting the default user elastic to role view only:
  #  - name: "elasticusersecret"
  #    username: "elastic"
  #    roles: "viewer"
  extraSecrets: []
  
  # -- Customization of ElasticSearchs PodDisruptionBudget Policy.
  # Elastic Cloud on Kubernetes operator (ECK) creates a default PodDisruptionBudget Policy.
  podDisruptionBudget:
    # -- Whether a PodDisruptionBudget Policy should be created.
    # Enabled=true results in ECK deploying the default (or custom, see data) PodDisruptionBudget Policy.
    # Enabled=false results in no PodDisruptionBudget Policy deployment.
    enabled: true
    # -- Overwrite the default PodDisruptionBudget Policy.
    # Overwriting with custom PodDisruptionBudget Policy requires enabled=true.
    # Examples can be seen here: https://kubernetes.io/docs/tasks/run-application/configure-pdb/
    data: {}

  # -- Enable and configure service account creation.
  serviceAccount:
    # -- Whether to create a ServiceAccount for Elasticsearch
    create: false
    # -- Name of the ServiceAccount for Elasticsearch
    name: ""
    # -- Name of the ServiceAccount Role used by the Elasticsearch ServiceAccount.
    # Requires create=true to work.
    roleName: ""
  
  # -- Whether the communication from APIGW and Kibana should be HTTPS
  # Note: you will need to create certificate and a separate truststore for the communication.
  tlsEnabled: false

  # -- The name of the elasticsearch secret. By default it will created by the fullname + "-es-tls-secret" if tlsEnabled is set to true.
  tlsSecretName: ""

  # -- The secret name that holds the keystore password  
  keystoreSecretName: ""

  # -- The name of the secret holding the tls secret
  # By default the name will be fullname of release + "es-tls-secret"
  certificateSecretName: "{{ include \"common.names.fullname\" .}}-es-tls-secret"
  
  # -- Node sets. See official ElasticSearch documentation at:
  # https://www.elastic.co/guide/en/cloud-on-k8s/current/k8s-orchestration.html
  # if you specify node sets here the defaultNodeSet will not be used.
  nodeSets: []
  
  # -- Default Node Set
  defaultNodeSet:

    # -- the number of replicas for Elastic Search
    count: 1
    # -- Set this to true for production workloads, this will also 
    # use an init container to increase the vm.max_map_count to 262144 on the nodes.
    memoryMapping: false    

    # -- Controls whether to start an init container that increases the vm.max_map_count to 262144 on the node.
    # Set memoryMapping to true and this setting also to true to run the init container.
    # Note that this requires the ability to run privileged containers, which is likely not the case on many secure clusters.
    setMaxMapCount: true     
    installMapperSizePlugin: true

    # -- Extra configuration parameters for Elasticsearch nodes to be appended to the default (none).
    # See https://www.elastic.co/guide/en/cloud-on-k8s/current/k8s-node-configuration.html
    extraConfig: {}

    # -- Extra init containers to be started before Elasticsearch nodes are started.
    # See https://www.elastic.co/guide/en/cloud-on-k8s/current/k8s-init-containers-plugin-downloads.html
    extraInitContainers: {}  

    # -- Annotations for Elasticsearch
    annotations: {}
  

kibana:
  # -- The ECK version to be used
  version: 8.2.3

  # -- The image that should be used.
  # By default ECK will use the official Elasticsearch images. 
  # Overwrite this to use an image from an internal registry or any custom images.
  # Make sure that the image corresponds to the version field.
  image: 

  # -- The default Kibana Port
  port: 5601

  # -- Annotations for Kibana
  annotations: {}
  
  # -- The secret name that holds the kibana user for API Gateway.
  secretName: ""

  # -- The pod securityContext for kibana pod.
  podSecurityContext: {}

  # -- The securityContext for kibana container.
  securityContext: {}

  # -- The definition of extra initContainers for kibana.
  extraInitContainers: []

  # -- Resource Settings for Kibana
  # Example: 
  # 
  # limits:
  #   cpu: 100m
  #   memory: 128Mi
  # requests:
  #   cpu: 100m
  #   memory: 128Mi  
  resources: {}

  # -- Additional labels to be added to kibana pod labels.
  extraLabels: {}

  # -- Enable and configure service account creation.
  serviceAccount:
    # -- Whether to create a ServiceAccount for Kibana
    create: false
    # -- Name of the ServiceAccount for Kibana
    name: ""
    # -- Name of the ServiceAccount Role used by the Kibana ServiceAccount.
    # Requires create=true to work.
    roleName: ""
  
# -- Elasticsearch exporter settings. See https://github.com/prometheus-community/elasticsearch_exporter for details.
prometheus-elasticsearch-exporter:

  # -- Deploy the prometheus exporter for elasticsearch
  enabled: true

  # -- secret for elasticsearch user. Will need to adjust the secret's name. By default the secret name is <releasename>-apigateway-sag-user-es.
  # Adjust accordingly if your release name is different. 
  extraEnvSecrets:
    ES_PASSWORD:
      secret: apigw-apigateway-sag-user-es
      key: password
    ES_USER:
      secret: apigw-apigateway-sag-user-es
      key: username

  es:
    # -- The uri of the elasticsearch service. By default this is null and the environment variable ES_URI is used instead.
    # Overwrite this if you are using an external Elasticsearch instance
    uri: "http://$(ES_USER):$(ES_PASSWORD)@apigw-apigateway-es-http:9200"
  
  serviceMonitor:
    enabled: false

  podAnnotations:
    prometheus.io/path: /metrics
    prometheus.io/port: "9108"
    prometheus.io/scheme: http
    prometheus.io/scrape: "true"